/*
 * Copyright (c) 2011 Veselin Georgiev
 *
 * Cutting the bullshit:
 *  all sources here are free software; you can use them for everything you
 *  want. Just don't blame me if something goes wrong; if something happens
 *  (including, but not limited to:
 *     coredumps, formatted harddrives, ping timeouts, winamp sound skips,
 *     fried GPUs, sudden mother-in-law visits, timelimits, penis enlargement
 *     pills spam, raytracing courses, Stroeja zaporkings, Gogov getting drunk,
 *     Pesho chatting up romanian girls in the subway, incorrect global
 *     illumination, strong ionizing radiation, earthquakes, frog rain,
 *     Windows 8 installations, dangerous sporks, concrete donkey, apocalypse,
 *     or even Genadzi Karatkevich getting your butt kicked...
 *  ), then you know you have been warned.
 *
 *
 *=======[ Quote of the Month: ]=======
 *
 * "The trouble with quotes on the Internet is that it's difficult to determine
 * whether or not they are genuine." --Abraham Lincoln
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <algorithm>
#include <queue>
#include <set>
#include <vector>
#include "utils.h"
#include "quickset.h"
#ifdef __linux__
#include <unistd.h>
#endif
using namespace std;

const char* INFILE = "flood-it.in";
const char* OUTFILE= "flood-it.out";
const double TIMELIMIT = 0.9;
const int MAXN = 384;
const int MAXC = 512;

struct Solution {
	int x, y;
	int steps;
	vector<int> colors;
};

int n, c;
int a[MAXN][MAXN], b[MAXN][MAXN], ff[MAXN][MAXN];
int fwdmap[512]; // from input color to workcolor
int bwdmap[512]; // from workcolor to input color
Solution bestSol;
const int dir[4][2] = { { -1, 0 }, { 1, 0 }, { 0, -1 }, { 0,  1 } };
int fillstate[MAXN*MAXN];

void input(bool generateRandom = false)
{
	FILE* f = NULL;
	if (!generateRandom)
		f = fopen(INFILE, "rt");
	//
	memset(fwdmap, 0xff, sizeof(fwdmap));
	int useless;
	c = 0;
	if (generateRandom) n = 350;
	else fscanf(f, "%d%d", &n, &useless);
	FOR(i, n) FOR(j, n) {
		int x;
		if (generateRandom) x = rand() % 3 + 1;
		else fscanf(f, "%d", &x);
		if (fwdmap[x] == -1) {
			fwdmap[x] = c;
			bwdmap[c] = x;
			c++;
		}
		a[i][j] = fwdmap[x];
	}
	debugf("Initial board:\n");
	FOR(i, n) {
		FOR(j, n) debugf("%d ", a[i][j]);
		debugf("\n");
	}
	//
	if (!generateRandom) fclose(f);
}

void randomInput(void)
{
	input(true);
}

struct GraphVertex {
	int color;
	int exampleX, exampleY;
	int ncells;
	vector<int> neighs;
};

vector<GraphVertex> g;

void floodFill(int x, int y, int color, int no, int& ncells)
{
	ncells = 1;
	b[x][y] = no;
	queue<pair<int, int> > Q;
	Q.push(make_pair(x, y));
	while (!Q.empty()) {
		int sx, sy;
		sx = Q.front().first;
		sy = Q.front().second;
		Q.pop();
		FOR(ii, 4) {
			int nx = sx + dir[ii][0];
			int ny = sy + dir[ii][1];
			if (nx >= 0 && nx < n && ny >= 0 && ny < n && a[nx][ny] == color && !b[nx][ny]) {
				b[nx][ny] = no;
				ncells++;
				Q.push(make_pair(nx, ny));
			}
		}
	}
}

void floodFill2(int x, int y, GraphVertex& vtx)
{
	QuickSet neighs;
	ff[x][y] = 1;
	queue<pair<int, int> > Q;
	Q.push(make_pair(x, y));
	while (!Q.empty()) {
		int sx, sy;
		sx = Q.front().first;
		sy = Q.front().second;
		Q.pop();
		FOR(ii, 4) {
			int nx = sx + dir[ii][0];
			int ny = sy + dir[ii][1];
			if (!(nx >= 0 && nx < n && ny >= 0 && ny < n)) continue;
			if (a[nx][ny] != vtx.color) neighs.insert(b[nx][ny]);
			else if (!ff[nx][ny]) {
				ff[nx][ny] = 1;
				Q.push(make_pair(nx, ny));
			}
		}
	}
	neighs.getAllElements(vtx.neighs);
}

void convertToGraph()
{
	g.clear();
	memset(b, 0, sizeof(b));
	int cc = 0;
	FOR(x, n) FOR(y, n) if (!b[x][y]) {
		cc++;
		GraphVertex v;
		floodFill(x, y, a[x][y], cc, v.ncells);
		v.color = a[x][y];
		v.exampleX = x;
		v.exampleY = y;
		g.push_back(v);
	}
	FOR(x, n) FOR(y, n) b[x][y]--;
	memset(ff, 0, sizeof(ff));
	REP(i, g) {
		int x = g[i].exampleX;
		int y = g[i].exampleY;
		floodFill2(x, y, g[i]);
	}
	debugf("Graph:\n");
	int maxncells = 0;
	REP(i, g) {
		maxncells = max(maxncells, g[i].ncells);
		debugf("  node %d (%d cells with color %d, seed=[%d,%d]), links to: {", i, g[i].ncells, g[i].color, g[i].exampleX, g[i].exampleY);
		for (int j = 0; j < (int) g[i].neighs.size(); j++) {
			if (j) debugf(",");
			debugf("%d", g[i].neighs[j]);
		}
		debugf("}\n");
	}
	debugf("maxncells = %d\n", maxncells);
}

void probe(int startI)
{
	memset(fillstate, 0, sizeof(fillstate));
	int left = g.size() - 1;
	fillstate[startI] = 1;
	int colCnt[MAXC] = {0};
	set<int> nn;
	REP(i, g[startI].neighs) {
		int j = g[startI].neighs[i];
		nn.insert(j);
		fillstate[j] = 2;
		colCnt[g[j].color]++;
	}
	vector<int> logg;
	while (left) {
		int maxC = 0, bi = -1;
		for (int i = 0; i < c; i++)
			if (colCnt[i] > maxC) { maxC = colCnt[i]; bi = i; }
		vector<int> newOwned;
		for (set<int>::iterator it = nn.begin(); it != nn.end(); ++it) {
			if (g[*it].color == bi)
				newOwned.push_back(*it);
		}
		logg.push_back(bi);
		REP(i, newOwned) {
			REP(j, g[newOwned[i]].neighs) {
				int k = g[newOwned[i]].neighs[j];
				if (fillstate[k] == 0) {
					fillstate[k] = 2;
					colCnt[g[k].color]++;
					nn.insert(k);
				}
			}
		}
		REP(i, newOwned) {
			fillstate[newOwned[i]] = 1;
			nn.erase(newOwned[i]);
			colCnt[g[newOwned[i]].color]--;
		}
		left -= (int) newOwned.size();
		if ((int) logg.size() > bestSol.steps) return;
	}
	if ((int) logg.size() < bestSol.steps) {
		bestSol.steps = logg.size();
		bestSol.colors = logg;
		bestSol.x = g[startI].exampleX;
		bestSol.y = g[startI].exampleY;
		debugf("**found new best sol starting at node %d, length %d\n", startI, (int) logg.size());
	}
}

void solve(void)
{
	bestSol.steps = 999666111;
	convertToGraph();
	if (g.size() == 1) {
		bestSol.x = bestSol.y = 0;
		bestSol.steps = 0;
		bestSol.colors = vector<int>();
		return;
	}
	// 0 - sorted by connections
	// 1 - sorted by ncells
	vector<pair<int, int> > tagSort[2];
	REP(i, g) {
		tagSort[0].push_back(make_pair(int(g[i].neighs.size()), i));
		tagSort[1].push_back(make_pair(g[i].ncells, i));
	}
	sort(tagSort[0].begin(), tagSort[0].end());
	sort(tagSort[1].begin(), tagSort[1].end());
	vector<int> done(g.size(), 0);
	int m = (int) g.size();
	int left[2] = {0, 0}, right[2] = {m - 1, m - 1};
	for (int pidx = 0; ; pidx++) {
		if (btime() > TIMELIMIT) break;
		if (left[0] >= m && right[0] < 0 && left[1] >= m && right[1] < 0) break;
		int ii = -1;
		int *mod, idx, dir;
		switch (pidx % 4) {
			case 0:
				mod = &left[0];
				idx = 0;
				dir = 1;
				break;
			case 1:
				mod = &left[1];
				idx = 1;
				dir = 1;
				break;
			case 2:
				mod = &right[0];
				idx = 0;
				dir = -1;
				break;
			case 3:
				mod = &right[1];
				idx = 1;
				dir = -1;
				break;
		}
		while (*mod >= 0 && *mod < m && done[tagSort[idx][*mod].second]) (*mod) += dir;
		if (*mod >= 0 && *mod < m) ii = tagSort[idx][*mod].second;
		else continue;
		done[ii] = true;
		probe(ii);
	}
}

void output(void)
{
	FILE* f = fopen(OUTFILE, "wt");
	fprintf(f, "%d\n", (int) bestSol.colors.size());
	fprintf(f, "%d %d\n", bestSol.x, bestSol.y);
	for (int i = 0; i < (int) bestSol.colors.size(); i++)
		fprintf(f, "%d\n", bwdmap[bestSol.colors[i]]);
	fclose(f);
}


int main(void)
{
/*#ifdef __linux__
	chdir("/home/vesko/develop/private/musala/floodit");
#endif*/
	btime();
	input();
	//randomInput();
	solve();
	output();
	debugf("Elapsed time: %.2lf\n", btime());
	return 0;
}
